<template>
  <div class="box-graphics">
    <div class="d-flex justify-end">
      <configuration
        class=""
        @reloadPlanificationCharts="reloadCharts"
      ></configuration>
      <seguimiento class="ml-5"></seguimiento>
    </div>
    <h3 class="text-center tway-header-1">Planificación</h3>
    <div class="mx-auto my-auto mt-6" max-width="auto">
      <div class="resumen">
        <div class="resumen-detail">
          <div class="mb-3 tway-violet--text">
            <p style="font-size: 18px">Resumen</p>
          </div>
          <div class="resumen-detail-item">
            <div>Avance Real:</div>
            <div class="resumen-detail-item-data">
              <div>{{ summaryPlanification.data.real }}%</div>
              <div></div>
            </div>
          </div>
          <div class="resumen-detail-item">
            <div>Avance Esperado:</div>
            <div class="resumen-detail-item-data">
              <div>{{ summaryPlanification.data.esperado }}%</div>
              <div></div>
            </div>
          </div>
          <div class="resumen-detail-item">
            <div>Desviación:</div>
            <div class="resumen-detail-item-data">
              <div>{{ summaryPlanification.data.atraso }}%</div>
              <div>
                <v-img
                  width="25"
                  :src="require('@/assets/img/pmo/down-arrow-red.svg')"
                />
              </div>
            </div>
          </div>
          <div class="resumen-detail-item">
            <div>Inicio Real:</div>
            <div class="resumen-detail-item-data">
              <div>04/02/2022</div>
              <div></div>
            </div>
          </div>
          <div class="resumen-detail-item">
            <div>Término Planificado:</div>
            <div class="resumen-detail-item-data">
              <div>15/06/2022</div>
              <div></div>
            </div>
          </div>
        </div>
        <div class="resumen-bar">
          <VueApexCharts
            :series="summaryPlanification.series"
            :options="summaryPlanification.options"
            type="bar"
            height="150"
            class="full"
          />
        </div>
      </div>

      <div class="d-flex flex-row align-center">
        <div>
          <div></div>
        </div>
      </div>
    </div>
    <v-card class="mx-auto my-auto mt-6" max-width="auto">
      <div class="mx-4 mt-5 pt-5 tway-violet--text">
        <p>Seguimiento por Mes</p>
      </div>
      <div v-if="charts.timeLine.serie">
        <timeline-chart :serie="charts.timeLine.serie"></timeline-chart>
      </div>
      <div v-else>Cargando...</div>
    </v-card>
    <div class="box-table">
      <div class="box-table-title tway-violet--text">Cumplimiento</div>
      <div class="multi-table-content">
        <div
          class="d-flex fontSizeUl flex-column ml-4 mt-2 box-tabla-etapa"
        ></div>
      </div>
      <table class="table-planification">
        <tr>
          <th class="first-th"></th>
          <th class="first-th" colspan="3">AVANCE</th>
          <th class="first-th" colspan="3">INICIO</th>
          <th class="first-th" colspan="3">TÉRMINO</th>
          <th class="first-th">NOMBRE</th>
        </tr>
        <tr>
          <th class="second-th">Nombre</th>
          <th class="second-th">Planificado</th>
          <th class="second-th">Real</th>
          <th class="second-th">%Desviación</th>
          <th class="second-th">Planificado</th>
          <th class="second-th">Real</th>
          <th class="second-th">%Desviación</th>
          <th class="second-th">Planificado</th>
          <th class="second-th">Real</th>
          <th class="second-th">%Desviación</th>
          <th class="second-th">RESPONSABLE</th>
        </tr>
        <tr v-for="(entry, i) in accomplishments" :key="i">
          <template v-if="entry.type !== '0'">
            <td style="text-align: left !important">{{ entry.nombre }}</td>
            <td class="left-border-td">{{ entry.avancePlanificado }}%</td>
            <td>
              {{ entry.avanceReal }}
              {{ entry.avanceReal == "" ? "" : "%" }}
            </td>
            <td class="right-border-td">
              {{ entry.desviacionAvance
              }}{{ entry.desviacionAvance == "" ? "" : "%" }}
              <img
                v-if="entry.desviacionAvance > 0"
                width="10px"
                :src="require('@/assets/img/pmo/up-arrow-green.svg')"
              />
              <img
                v-if="entry.desviacionAvance < 0"
                width="10px"
                :src="require('@/assets/img/pmo/down-arrow-red.svg')"
              />
            </td>
            <td class="left-border-td">{{ entry.fechaInicioPlanificado }}</td>
            <td>{{ entry.fechaInicioReal }}</td>
            <td class="right-border-td">{{ entry.desviacionDiasInicio }}</td>
            <td class="left-border-td">{{ entry.fechaTerminoPlanificado }}</td>
            <td>{{ entry.fechaTerminoReal }}</td>
            <td class="right-border-td">
              {{ entry.desviacionDiasTermino }}
              <template v-if="entry.desviacionDiasTermino">
                <img
                  v-if="entry.desviacionDiasTermino > 0"
                  width="10px"
                  :src="require('@/assets/img/pmo/up-arrow-green.svg')"
                />
                <img
                  v-if="entry.desviacionDiasTermino < 0"
                  width="10px"
                  :src="require('@/assets/img/pmo/down-arrow-red.svg')"
                />
              </template>
            </td>
            <td class="right-border-td">{{ entry.nombreMiembro }}</td>
          </template>
          <template v-else>
            <th style="text-align: left !important" class="inter-table-th">
              {{ entry.nombre }}
            </th>
            <th class="left-border-th inter-table-th">
              {{ entry.avancePlanificado }}%
            </th>
            <th class="inter-table-th">
              {{ entry.avanceReal }}
              {{ entry.avanceReal == "" ? "" : "%" }}
            </th>
            <th class="right-border-th inter-table-th">
              {{ entry.desviacionAvance
              }}{{ entry.desviacionAvance == "" ? "" : "%" }}
              <img
                v-if="Math.round(entry.desviacionAvance * 100) > 0"
                width="10px"
                :src="require('@/assets/img/pmo/up-arrow-green.svg')"
              />
              <img
                v-if="entry.desviacionAvance < 0"
                width="10px"
                :src="require('@/assets/img/pmo/down-arrow-red.svg')"
              />
            </th>
            <th class="left-border-th inter-table-th">
              {{ entry.fechaInicioPlanificado }}
            </th>
            <th class="inter-table-th">{{ entry.fechaInicioReal }}</th>
            <th class="right-border-th inter-table-th">
              {{ entry.desviacionDiasInicio }}
            </th>
            <th class="left-border-th inter-table-th">
              {{ entry.fechaTerminoPlanificado }}
            </th>
            <th>{{ entry.fechaTerminoReal }}</th>
            <th class="right-border-th inter-table-th">
              {{ entry.desviacionDiasTermino }}
              <template v-if="entry.desviacionDiasTermino">
                <img
                  v-if="entry.desviacionDiasTermino > 0"
                  width="10px"
                  :src="require('@/assets/img/pmo/up-arrow-green.svg')"
                />
                <img
                  v-else
                  width="10px"
                  :src="require('@/assets/img/pmo/down-arrow-red.svg')"
                />
              </template>
            </th>
            <th class="right-border-th">
              {{ entry.nombreResponsable }}
            </th>
          </template>
        </tr>
      </table>
    </div>
  </div>
</template>

<script>
import TimelineChart from "@/components/charts/pmo/apex/TimeLineChart.vue";
import Configuration from "../../components/pmo/planification/configuration.vue";
import Seguimiento from "../../components/pmo/planification/seguimiento.vue";
import PlanificationService from "@/services/pmo/planification/planificationService";
//import StackedBars100 from "../../components/charts/pmo/apex/bar/StackedBars100";
import VueApexCharts from "vue-apexcharts";

export default {
  components: {
    // StackedBars100,
    TimelineChart,
    Configuration,
    Seguimiento,
    VueApexCharts,
  },
  data() {
    return {
      summaryPlanification: {
        data: Object,
        series: [],
        options: {
          chart: {
            type: "bar",
            height: 180,
            width: "100%",
            stacked: true,
            fontFamily: "Josefin Sans, Arial, sans-serif",
            toolbar: {
              show: false,
            },
          },
          plotOptions: {
            bar: {
              horizontal: true,
            },
          },
          stroke: {
            width: 0,
            colors: ["#fff"],
            curve: "smooth",
            lineCap: "round",
            dashArray: 0,
          },
          title: {
            text: "",
          },
          xaxis: {
            categories: [""],
            labels: {
              formatter: function (val) {
                return val;
              },
            },
          },
          yaxis: {
            title: {
              text: undefined,
            },
          },
          tooltip: {
            y: {
              formatter: function (val) {
                return val + "%";
              },
            },
          },
          fill: {
            opacity: 1,
          },
          colors: ["#16C62E", "#D7263D", "#7319D5", "#4A148C"],
          legend: {
            position: "left",
            horizontalAlign: "left",
            offsetX: 0,
            offsetY: 40,
          },
        },
        series2: [
          {
            name: "Promotores",
            data: [49],
          },
          {
            name: "Neutros",
            data: [12],
          },
          {
            name: "Detractores",
            data: [13],
          },
        ],
        options2: {
          chart: {
            type: "bar",
            height: 150,
            stacked: true,
            //stackType: '100%'
          },
          plotOptions: {
            bar: {
              horizontal: true,
            },
          },
          stroke: {
            width: 1,
            colors: ["#fff"],
          },
          title: {
            text: "",
          },
          xaxis: {
            categories: ["Agosto"],
          },
          tooltip: {
            y: {
              formatter: function (val) {
                return val;
              },
            },
          },
          fill: {
            opacity: 1,
          },
          legend: {
            position: "top",
            horizontalAlign: "left",
            offsetX: 40,
          },
          colors: ["#008F39", "#E5Be01", "#D7263D"],
        },
      },

      accomplishments: [],
      charts: {
        fontFamily: "Josefin Sans, Arial, sans-serif",
        timeLine: {
          serie: null,
        },
        stacked: {
          serie: [],
        },
      },
      serieStacked: [],
    };
  },
  methods: {
    colorCelda(v) {
      return v.qualifier == -1 ? "rojo" : "azul";
    },
    reloadCharts() {
      let me = this;
      PlanificationService.getChartStagesAndActivities()
        .then((data) => {
          me.charts.timeLine.serie = data;
        })
        .catch((err) => console.dir(err));
    },
  },
  mounted() {
    PlanificationService.getChartStagesAndActivities()
      .then((data) => {
        this.charts.timeLine.serie = data;
      })
      .catch((err) => console.dir(err));

    PlanificationService.getChartSummary()
      .then((data) => {
        this.summaryPlanification.series = data.series;
        this.summaryPlanification.data = data.data;
      })
      .catch((err) => console.dir(err));

    PlanificationService.accomplishments(1)
      .then((data) => {
        console.log("========================= ACCOMPLISHMENTS =========");
        console.dir(data);
        console.log("========================= ACCOMPLISHMENTS =========");
        this.accomplishments = data;
      })
      .catch((err) => console.dir(err));
  },
};
</script>

<style scoped lang="scss">
.box-graphics {
  max-width: 1400px;
  min-width: 1100px;
}
.shrink {
  width: 150px;
}
.bar {
  width: 350px;
}

ul {
  list-style: none;
  padding: 0;
  margin: 0;
}

li {
  padding-left: 1em;
  text-indent: -0.7em;
}

li::before {
  content: "• ";
  color: red; /* or whatever color you prefer */
}

.fontSizeUl {
  font-size: 10px;
}
.rojo {
  border: 1px solid red;
}
.azul {
  border: 1px solid blue;
}
/*

table {
  border-collapse: collapse;
  width: 100%;
  text-align: center;
  font-size: 11px !important;
}

table tr {
  border: solid rgb(170, 164, 164) 0.5px;
}

table,
th {
  border: 1px solid grey;
}

th {
  vertical-align: top;
}
*/
// td:empty:after {
//   content: "\00a0"; /* HTML entity of &nbsp; */
// }

.table-planification {
  width: 100%;
  font-size: 11px;
  text-align: center;
  border: 0.5px solid rgb(185, 185, 185);
  border-collapse: collapse;
  .first-th {
    border: 0.5px solid rgb(185, 185, 185);
    width: 22%;
    height: 30px;
  }
  .first-th:last-child {
    border: 0.5px solid rgb(185, 185, 185);
    width: 10%;
    border-bottom: 0px;
  }
  .second-th {
    border: 0.5px solid rgb(185, 185, 185);
    width: 10%;
    height: 30px;
  }
  .left-border-td {
    border-left: 0.5px solid rgb(185, 185, 185);
  }

  .right-border-td {
    border-right: 0.5px solid rgb(185, 185, 185);
  }

  .left-border-th {
    border-left: 0.5px solid rgb(185, 185, 185);
  }

  .right-border-th {
    border-right: 0.5px solid rgb(185, 185, 185);
  }

  td {
    text-align: right;
    padding-right: 20px;
  }
  .inter-table-th {
    text-align: right;
    padding-right: 20px;
  }
}

.cabecera {
  font-weight: bold;
}
.resumen {
  display: flex;
  width: 100%;
  box-shadow: 0px 3px 1px -2px rgb(0 0 0 / 20%),
    0px 2px 2px 0px rgb(0 0 0 / 14%), 0px 1px 5px 0px rgb(0 0 0 / 12%);
  border-radius: 4px;
  justify-content: flex-start;
  margin: 25px 0px 25px 0px;
  padding-left: 25px;
}

.resumen > .resumen-detail {
  width: 20%;
  display: flex;
  flex-direction: column;
  margin-top: 20px;
  margin-bottom: 30px;
  font-size: 14px !important;
}
.resumen > .resumen-detail > .resumen-detail-item {
  width: 100%;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
}

.resumen > .resumen-detail > .resumen-detail-item > .resumen-detail-item-data {
  display: flex;
  width: 25%;
  justify-content: space-between;
}

.resumen
  > .resumen-detail
  > .resumen-detail-item
  > .resumen-detail-item-data
  > div:first-child {
  text-align: right;
  width: 60%;
}
.resumen
  > .resumen-detail
  > .resumen-detail-item
  > .resumen-detail-item-data
  > div {
  width: 30%;
}

.resumen > .resumen-bar {
  display: flex;
  width: 78%;
  height: auto;
  margin-top: 40px;
}
.resumen-title {
  display: flex;
  flex-direction: row;
  width: 100%;
  border: solid black 1px;
  justify-content: space-between;
}
.resumen-content {
  display: flex;
  flex-direction: row;
  width: 100%;
  border: solid black 1px;
  justify-content: space-between;
  margin-bottom: 15px;
}
.box-tabla {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  font-size: 10px !important;
  justify-content: center;
}

.box-tabla > .box-tabla-etapa {
  margin-right: 20px;
  margin-top: 29px !important;
  padding: 0px !important;
  text-align: center !important;
}
.box-tabla > .box-tabla-tabla {
  margin-left: 20px;
  font-size: 10px !important;
  padding: 0px !important;
}
.v-data-table > .v-data-table__wrapper > table > tbody > tr > td {
  font-size: 10px !important;
}

.table-sin-marco {
  border: 0px;
  text-align: center !important;
  border-bottom: 1px solid black;
}
.table-sin-marco {
  border: 0px;
  text-align: center !important;
  border-bottom: 1px solid black;
}

.box-table {
  width: 100%;
  display: flex;
  flex-direction: column;
  box-shadow: 0px 3px 1px -2px rgb(0 0 0 / 20%),
    0px 2px 2px 0px rgb(0 0 0 / 14%), 0px 1px 5px 0px rgb(0 0 0 / 12%);
  border-radius: 4px;
  justify-content: center;
  margin: 25px 0px 25px 0px;
  padding: 40px 10px 40px 10px;
  font-size: 13px;
}
.multi-table-content {
  display: flex;
  flex-direction: row;
  width: 100%;
}
.table-compliance {
  display: flex;
  flex-direction: column;
  border: 1px solid black;
  width: 90%;
  text-align: center;
}

.table-compliance-firts-header,
.table-compliance-second-header,
.table-compliance-content {
  display: flex;
  border: 1px solid black;
  width: 100%;
}
.table-compliance-firts-header div {
  width: 30%;
}

.table-compliance-firts-header div:last-child {
  width: 10%;
}

.table-compliance-second-header div {
  display: flex;
  width: 30%;
  font-size: 10px;
}

.table-compliance-second-header div:last-child {
  display: flex;
  width: 10%;
  font-size: 10px;
}

.table-compliance-second-header div .celda {
  display: flex;
  width: 33%;
  font-size: 10px;
  justify-content: center;
  font-weight: bold;
}

.table-compliance-content {
  border: 0px;
}

.table-compliance-content div {
  display: flex;
  width: 30%;
  font-size: 10px;
  text-align: center !important;
  justify-content: center;
}
.table-compliance-content > .celda-resp {
  display: flex;
  width: 10%;
  font-size: 10px;
  text-align: center !important;
  justify-content: center;
}

.table-compliance-content div .celda {
  display: flex;
  align-content: center;
  width: 33%;
  font-size: 10px;
  text-align: center !important;
  border: 0px;
  justify-content: center;
}

.table-compliance-content div > .celda-etapa {
  font-weight: bold;
}

.line-boder-right {
  border-right: 1px black solid !important;
}
.last-resposable-header {
  border: 0px;
}

.multi-table-content > .box-tabla-etapa {
  margin-right: 20px;
  padding: 0px !important;
  text-align: center !important;
  margin: 0px 15px 0px 25px;
}
.box-table-title {
  display: flex;
  font-size: 20px;
  margin-bottom: 15px;
}
.color-status {
  width: 5px;
  height: 5px;
  border-radius: 50px;
}
.etapa-list > li {
  list-style: none !important;
  display: flex;
  align-items: center;
}
.etapa-list > li > div:first-child {
  margin-right: 9px;
}
.full {
  width: 100%;
}
</style>
